/* Channel Robot v0.2 for the Ampr Converse Network!

   By Marius Petrescu, YO2LOJ


   Based on work by
      - Carl Makin
      - Adam Roach

   with lots stolen from other sources.

*/

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <ctype.h>
#include <sys/socket.h>
#include <sys/socketvar.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>

#define BOTNAME		"X-Bot"
#define VERSION		"0.2"
#define CALL		"yo2loj-x"
#define CHANNEL		"182"
#define TOPIC		"---===> Romanian Convers Channel <===---"
#define SERV_TCP_PORT	3600
#define SERV_HOST_ADDR	"127.0.0.1"


extern errno;
int sockfd;
pid_t pid;


int lsend(char *text) {
    int len;
    len = strlen(text);
    return send(sockfd, text, len, 0);
}

static void terminate(int sig)
{
    lsend("/q Arghhhh! Getting killed.\n");
    close(sockfd);    
    exit(0);
}


int readline(register char *ptr, register int maxlen)
{
  int	n, rc;
  char c;

  for(n = 1; n < maxlen; n++) {
     if ( (rc = read(sockfd, &c, 1)) == 1) {
        *ptr++ = c;
        if (c == '\n')
           break;
     } else if (rc == 0) {
               if (n == 1)
                        return(0);    /* EOF, no data was read */
                  else
                        break;  /* EOF, some data was read */ 
             } else
                   return(-1);    /* ERROR */
   }
   *ptr = 0;
   return(n);
}

static void checktopic(int sig)
{
  char			buffer[400];
  int 			xrc;
  lsend("/topic\n");
  xrc = readline(buffer, 399);
  if (xrc && buffer[2]=='*') xrc = readline(buffer, 399);
  if (xrc && buffer[2]=='*') xrc = readline(buffer, 399);
  if (!strstr(buffer, TOPIC))
    lsend("/topic " TOPIC "\n");
  alarm(60);
}

static void settopic(int sig)
{
      lsend("/topic " TOPIC "\n");
}

main()
{
  char			buffer[400];
  char *		cmd;
  int			xrc;
  struct sockaddr_in	serv_addr;

  printf(BOTNAME " v" VERSION " by Marius, YO2LOJ\n");

  bzero((char *) &serv_addr, sizeof(serv_addr));
  serv_addr.sin_family      = AF_INET;
  serv_addr.sin_addr.s_addr = inet_addr(SERV_HOST_ADDR);
  serv_addr.sin_port 	    = htons(SERV_TCP_PORT);

/* Open the tcp socket */

  if ( (sockfd = socket(AF_INET, SOCK_STREAM, 0)) <0) {
        printf(BOTNAME ": Can't open stream socket.\n");
	exit(1);
  }

/* Connect to the Server */

  if (connect(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) <0) {
        printf(BOTNAME ": Can't connect to server.\n");
	exit(1);
  }
  
  signal(SIGTERM, terminate);
  
  lsend("/n " CALL " " CHANNEL "\n");
  lsend("/pe " BOTNAME " v" VERSION "\n");
  lsend("/wi 200\n");
  lsend("/topic " TOPIC "\n");
  lsend("/away Just holding channel " CHANNEL "\n");
  

  pid = fork();
  if (-1 == pid)
  {
	fprintf(stderr, BOTNAME ": cannot become a daemon.\n");
	exit(1);
  }
  else if (pid)
  {
	exit(0);
  }

  signal(SIGHUP, settopic);
  
  signal(SIGALRM, checktopic);
  alarm(60);
  
  for(;;) {
    xrc = readline(buffer, 399);
    if (xrc > 0) {
      if(cmd = strstr(buffer, ": X:")) {
	cmd+=5;
	if (strlen(cmd)) {
	  cmd--;
	  if (strstr(cmd, "info")) {
	    lsend(BOTNAME " v" VERSION " by Marius, YO2LOJ <marius@yo2loj.ro>\n");
	  } 
	  else if (strstr(cmd, "help")) {
	    lsend("Available commands: help, info, topic\n");
	  }
	  else if (strstr(cmd, "topic")) {
	    lsend("/topic " TOPIC "\n");
	  }
	  else lsend("Only help, info and topic allowed\n");
	}
	else lsend ("what?\n");
      }
    } 
  }
}
